import sqlglot
from sqlglot.optimizer.qualify import qualify
from sqlglot.optimizer.qualify_tables import qualify_tables
import sqlparse as sqlparse


def process_query(query, read, case_sensitive, quote_identifiers):
    expression = sqlglot.parse_one(query, read=read)

    if case_sensitive == '1':
        return qualify_tables(expression, case_sensitive=True).sql() + ';'
    elif case_sensitive == '2':
        return qualify_tables(expression, case_sensitive=False).sql() + ';'
    elif quote_identifiers:
        return qualify(expression, quote_identifiers=False).sql() + ';'
    else:
        return query + ';'


def main(sql_query, read, write, source, case_sensitive, quote_identifiers):
    result = ''
    queries = sqlglot.transpile(sql_query, read=read, write=write)
    if source == 'text':
        if case_sensitive =='0' and quote_identifiers == False:
            result = sqlparse.format(queries[0], reindent_aligned=True)
        else:
            result = sqlparse.format(process_query(sql_query, read, case_sensitive, quote_identifiers), reindent_aligned=True)

    elif source == 'file':
        if case_sensitive == '0' and quote_identifiers == False:
            result = sqlparse.format(''.join(queries), reindent=True)
        else:
            queries = sql_query.split(';')
            result = sqlparse.format(''.join(process_query(query, read, case_sensitive, quote_identifiers) for query in queries), reindent=True)
    else:
        print("Invalid method specified.")

    print(result)





sql = """
select `fact_union_all`.`viewId` as `c0`, sum(`fact_union_all`.`vat_tax_payable`) as `m0`, sum(`fact_union_all`.`sale_income`) as `m1` from (select T339.`S_DATE`,T339.`vat_tax_payable`,T339.`sale_income`,T339.`divisionId`,T339.`area`,T339.`dept_id`,T339.`ID`,T339.`line_type`,T339.`dept_line`,T339.`dept_id5`,T339.`staff_id`,T339.`viewId` from `smartbimpp`.`Iff808081017d51cc51cce434017d5aeec35e7022` T339 /* RowPermission_start */ where ( (( T339.`divisionId` in( select divison_code from dbo.dm_division_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY2' or `viewId`='COMBINEDQUERY28' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY2','COMBINEDQUERY28','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18')) and ( (( T339.`line_type` in ( select dept_line from dbo.dm_invent_authority where staff_id = 'admin') ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY5' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY39' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY5','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY39','COMBINEDQUERY19')) and ( (( T339.`ID` in( select area_code from dbo.dm_area_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY6' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY26','COMBINEDQUERY6','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18','COMBINEDQUERY19')) and ( (( T339.`dept_id5` in( select dept_id from dbo.dm_dep_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY20' or `viewId`='COMBINEDQUERY22' or `viewId`='COMBINEDQUERY27' or `viewId`='COMBINEDQUERY12' or `viewId`='COMBINEDQUERY14' or `viewId`='COMBINEDQUERY15' or `viewId`='COMBINEDQUERY38') or `viewId` not in('COMBINEDQUERY20','COMBINEDQUERY22','COMBINEDQUERY27','COMBINEDQUERY12','COMBINEDQUERY14','COMBINEDQUERY15','COMBINEDQUERY38')) /* RowPermission_end */) as `fact_union_all` where (`fact_union_all`.`viewId` = 'COMBINEDQUERY30' or `fact_union_all`.`viewId` = 'COMBINEDQUERY31') and toString(toYear( toDate(`S_DATE`) )) || '-' || if(toMonth(toDate(`S_DATE`)) < 10, '0' || toString(toMonth(toDate(`S_DATE`))), toString(toMonth(toDate(`S_DATE`)))) = '2021-11' group by `c0`;
select `fact_union_all`.`viewId` as `c0`, sum(`fact_union_all`.`all_tax_payable`) as `m0`, sum(`fact_union_all`.`sale_income`) as `m1` from (select T339.`S_DATE`,T339.`all_tax_payable`,T339.`sale_income`,T339.`divisionId`,T339.`area`,T339.`dept_id`,T339.`ID`,T339.`line_type`,T339.`dept_line`,T339.`dept_id5`,T339.`staff_id`,T339.`viewId` from `smartbimpp`.`Iff808081017d51cc51cce434017d5aeec35e7022` T339 /* RowPermission_start */ where ( (( T339.`divisionId` in( select divison_code from dbo.dm_division_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY2' or `viewId`='COMBINEDQUERY28' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY2','COMBINEDQUERY28','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18')) and ( (( T339.`line_type` in ( select dept_line from dbo.dm_invent_authority where staff_id = 'admin') ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY5' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY39' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY5','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY39','COMBINEDQUERY19')) and ( (( T339.`ID` in( select area_code from dbo.dm_area_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY6' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY26','COMBINEDQUERY6','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18','COMBINEDQUERY19')) and ( (( T339.`dept_id5` in( select dept_id from dbo.dm_dep_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY20' or `viewId`='COMBINEDQUERY22' or `viewId`='COMBINEDQUERY27' or `viewId`='COMBINEDQUERY12' or `viewId`='COMBINEDQUERY14' or `viewId`='COMBINEDQUERY15' or `viewId`='COMBINEDQUERY38') or `viewId` not in('COMBINEDQUERY20','COMBINEDQUERY22','COMBINEDQUERY27','COMBINEDQUERY12','COMBINEDQUERY14','COMBINEDQUERY15','COMBINEDQUERY38')) /* RowPermission_end */) as `fact_union_all` where (`fact_union_all`.`viewId` = 'COMBINEDQUERY30' or `fact_union_all`.`viewId` = 'COMBINEDQUERY31') and (toString(toYear( toDate(`S_DATE`) )) || '-' || if(toMonth(toDate(`S_DATE`)) < 10, '0' || toString(toMonth(toDate(`S_DATE`))), toString(toMonth(toDate(`S_DATE`)))) = '2021-11' and toString(toYear( toDate(`S_DATE`) )) = '2021') group by `c0`;
select `fact_union_all`.`viewId` as `c0`, sum(`fact_union_all`.`total_cost`) as `m0` from (select T339.`S_DATE`,T339.`total_cost`,T339.`divisionId`,T339.`area`,T339.`dept_id`,T339.`ID`,T339.`line_type`,T339.`dept_line`,T339.`dept_id5`,T339.`staff_id`,T339.`viewId` from `smartbimpp`.`Iff808081017d51cc51cce434017d5aeec35e7022` T339 /* RowPermission_start */ where ( (( T339.`divisionId` in( select divison_code from dbo.dm_division_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY2' or `viewId`='COMBINEDQUERY28' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY2','COMBINEDQUERY28','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18')) and ( (( T339.`line_type` in ( select dept_line from dbo.dm_invent_authority where staff_id = 'admin') ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY5' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY39' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY5','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY39','COMBINEDQUERY19')) and ( (( T339.`ID` in( select area_code from dbo.dm_area_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY6' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY26','COMBINEDQUERY6','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18','COMBINEDQUERY19')) and ( (( T339.`dept_id5` in( select dept_id from dbo.dm_dep_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY20' or `viewId`='COMBINEDQUERY22' or `viewId`='COMBINEDQUERY27' or `viewId`='COMBINEDQUERY12' or `viewId`='COMBINEDQUERY14' or `viewId`='COMBINEDQUERY15' or `viewId`='COMBINEDQUERY38') or `viewId` not in('COMBINEDQUERY20','COMBINEDQUERY22','COMBINEDQUERY27','COMBINEDQUERY12','COMBINEDQUERY14','COMBINEDQUERY15','COMBINEDQUERY38')) /* RowPermission_end */) as `fact_union_all` where `fact_union_all`.`viewId` = 'COMBINEDQUERY30' and (toString(toYear( toDate(`S_DATE`) )) || '-' || if(toMonth(toDate(`S_DATE`)) < 10, '0' || toString(toMonth(toDate(`S_DATE`))), toString(toMonth(toDate(`S_DATE`)))) = '2021-11' and toString(toYear( toDate(`S_DATE`) )) = '2021') group by `c0`;
select `fact_union_all`.`viewId` as `c0`, sum(`fact_union_all`.`total_assets`) as `m0`, sum(`fact_union_all`.`total_liabilities`) as `m1` from (select T339.`S_DATE`,T339.`total_assets`,T339.`total_liabilities`,T339.`divisionId`,T339.`area`,T339.`dept_id`,T339.`ID`,T339.`line_type`,T339.`dept_line`,T339.`dept_id5`,T339.`staff_id`,T339.`viewId` from `smartbimpp`.`Iff808081017d51cc51cce434017d5aeec35e7022` T339 /* RowPermission_start */ where ( (( T339.`divisionId` in( select divison_code from dbo.dm_division_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY2' or `viewId`='COMBINEDQUERY28' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY2','COMBINEDQUERY28','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18')) and ( (( T339.`line_type` in ( select dept_line from dbo.dm_invent_authority where staff_id = 'admin') ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY5' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY39' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY5','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY39','COMBINEDQUERY19')) and ( (( T339.`ID` in( select area_code from dbo.dm_area_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY6' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY26','COMBINEDQUERY6','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18','COMBINEDQUERY19')) and ( (( T339.`dept_id5` in( select dept_id from dbo.dm_dep_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY20' or `viewId`='COMBINEDQUERY22' or `viewId`='COMBINEDQUERY27' or `viewId`='COMBINEDQUERY12' or `viewId`='COMBINEDQUERY14' or `viewId`='COMBINEDQUERY15' or `viewId`='COMBINEDQUERY38') or `viewId` not in('COMBINEDQUERY20','COMBINEDQUERY22','COMBINEDQUERY27','COMBINEDQUERY12','COMBINEDQUERY14','COMBINEDQUERY15','COMBINEDQUERY38')) /* RowPermission_end */) as `fact_union_all` where `fact_union_all`.`viewId` = 'COMBINEDQUERY30' and toString(toYear( toDate(`S_DATE`) )) || '-' || if(toMonth(toDate(`S_DATE`)) < 10, '0' || toString(toMonth(toDate(`S_DATE`))), toString(toMonth(toDate(`S_DATE`)))) = '2021-11' group by `c0`;
select toString(toYear( toDate(`S_DATE`) )) as `c0`, toString(toYear( toDate(`S_DATE`) )) || '-' || if(toMonth(toDate(`S_DATE`)) < 10, '0' || toString(toMonth(toDate(`S_DATE`))), toString(toMonth(toDate(`S_DATE`)))) as `c1` from (select T339.`S_DATE`,T339.`divisionId`,T339.`area`,T339.`dept_id`,T339.`ID`,T339.`line_type`,T339.`dept_line`,T339.`dept_id5`,T339.`staff_id`,T339.`viewId` from `smartbimpp`.`Iff808081017d51cc51cce434017d5aeec35e7022` T339 /* RowPermission_start */ where ( (( T339.`divisionId` in( select divison_code from dbo.dm_division_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY2' or `viewId`='COMBINEDQUERY28' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY2','COMBINEDQUERY28','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18')) and ( (( T339.`line_type` in ( select dept_line from dbo.dm_invent_authority where staff_id = 'admin') ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY5' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY39' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY5','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY39','COMBINEDQUERY19')) and ( (( T339.`ID` in( select area_code from dbo.dm_area_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY6' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY26','COMBINEDQUERY6','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18','COMBINEDQUERY19')) and ( (( T339.`dept_id5` in( select dept_id from dbo.dm_dep_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY20' or `viewId`='COMBINEDQUERY22' or `viewId`='COMBINEDQUERY27' or `viewId`='COMBINEDQUERY12' or `viewId`='COMBINEDQUERY14' or `viewId`='COMBINEDQUERY15' or `viewId`='COMBINEDQUERY38') or `viewId` not in('COMBINEDQUERY20','COMBINEDQUERY22','COMBINEDQUERY27','COMBINEDQUERY12','COMBINEDQUERY14','COMBINEDQUERY15','COMBINEDQUERY38')) /* RowPermission_end */) as `fact_union_all` group by `c0`, `c1` order by CASE WHEN `c0` IS NULL THEN 1 ELSE 0 END, `c0` ASC, CASE WHEN `c1` IS NULL THEN 1 ELSE 0 END, `c1` ASC;
select toString(toYear( toDate(`S_DATE`) )) as `c0`, toString(toYear( toDate(`S_DATE`) )) || '-' || if(toMonth(toDate(`S_DATE`)) < 10, '0' || toString(toMonth(toDate(`S_DATE`))), toString(toMonth(toDate(`S_DATE`)))) as `c1` from (select T339.`S_DATE`,T339.`divisionId`,T339.`area`,T339.`dept_id`,T339.`ID`,T339.`line_type`,T339.`dept_line`,T339.`dept_id5`,T339.`staff_id`,T339.`viewId` from `smartbimpp`.`Iff808081017d51cc51cce434017d5aeec35e7022` T339 /* RowPermission_start */ where ( (( T339.`divisionId` in( select divison_code from dbo.dm_division_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY2' or `viewId`='COMBINEDQUERY28' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY2','COMBINEDQUERY28','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18')) and ( (( T339.`line_type` in ( select dept_line from dbo.dm_invent_authority where staff_id = 'admin') ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY5' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY39' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY5','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY39','COMBINEDQUERY19')) and ( (( T339.`ID` in( select area_code from dbo.dm_area_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY6' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY26','COMBINEDQUERY6','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18','COMBINEDQUERY19')) and ( (( T339.`dept_id5` in( select dept_id from dbo.dm_dep_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY20' or `viewId`='COMBINEDQUERY22' or `viewId`='COMBINEDQUERY27' or `viewId`='COMBINEDQUERY12' or `viewId`='COMBINEDQUERY14' or `viewId`='COMBINEDQUERY15' or `viewId`='COMBINEDQUERY38') or `viewId` not in('COMBINEDQUERY20','COMBINEDQUERY22','COMBINEDQUERY27','COMBINEDQUERY12','COMBINEDQUERY14','COMBINEDQUERY15','COMBINEDQUERY38')) /* RowPermission_end */) as `fact_union_all` group by `c0`, `c1` order by CASE WHEN `c0` IS NULL THEN 1 ELSE 0 END, `c0` ASC, CASE WHEN `c1` IS NULL THEN 1 ELSE 0 END, `c1` ASC;
select null as `c0`, toString(toYear( toDate(`S_DATE`) )) as `c1`, null as `c2`, toString(toYear( toDate(`S_DATE`) )) || '-' || if(toMonth(toDate(`S_DATE`)) < 10, '0' || toString(toMonth(toDate(`S_DATE`))), toString(toMonth(toDate(`S_DATE`)))) as `c3`, null as `c4` from (select T339.`S_DATE`,T339.`divisionId`,T339.`area`,T339.`dept_id`,T339.`ID`,T339.`line_type`,T339.`dept_line`,T339.`dept_id5`,T339.`staff_id`,T339.`viewId` from `smartbimpp`.`Iff808081017d51cc51cce434017d5aeec35e7022` T339 /* RowPermission_start */ where ( (( T339.`divisionId` in( select divison_code from dbo.dm_division_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY2' or `viewId`='COMBINEDQUERY28' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY2','COMBINEDQUERY28','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18')) and ( (( T339.`line_type` in ( select dept_line from dbo.dm_invent_authority where staff_id = 'admin') ) ) and (`viewId`='COMBINEDQUERY23' or `viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY5' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY37' or `viewId`='COMBINEDQUERY10' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY39' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY23','COMBINEDQUERY26','COMBINEDQUERY5','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY37','COMBINEDQUERY10','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY39','COMBINEDQUERY19')) and ( (( T339.`ID` in( select area_code from dbo.dm_area_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY26' or `viewId`='COMBINEDQUERY6' or `viewId`='COMBINEDQUERY9' or `viewId`='COMBINEDQUERY7' or `viewId`='COMBINEDQUERY8' or `viewId`='COMBINEDQUERY13' or `viewId`='COMBINEDQUERY36' or `viewId`='COMBINEDQUERY11' or `viewId`='COMBINEDQUERY16' or `viewId`='COMBINEDQUERY38' or `viewId`='COMBINEDQUERY18' or `viewId`='COMBINEDQUERY19') or `viewId` not in('COMBINEDQUERY26','COMBINEDQUERY6','COMBINEDQUERY9','COMBINEDQUERY7','COMBINEDQUERY8','COMBINEDQUERY13','COMBINEDQUERY36','COMBINEDQUERY11','COMBINEDQUERY16','COMBINEDQUERY38','COMBINEDQUERY18','COMBINEDQUERY19')) and ( (( T339.`dept_id5` in( select dept_id from dbo.dm_dep_authority where staff_id = 'admin' ) ) ) and (`viewId`='COMBINEDQUERY20' or `viewId`='COMBINEDQUERY22' or `viewId`='COMBINEDQUERY27' or `viewId`='COMBINEDQUERY12' or `viewId`='COMBINEDQUERY14' or `viewId`='COMBINEDQUERY15' or `viewId`='COMBINEDQUERY38') or `viewId` not in('COMBINEDQUERY20','COMBINEDQUERY22','COMBINEDQUERY27','COMBINEDQUERY12','COMBINEDQUERY14','COMBINEDQUERY15','COMBINEDQUERY38')) /* RowPermission_end */) as `fact_union_all` group by `c1`, `c3` order by CASE WHEN `c1` IS NULL THEN 1 ELSE 0 END, `c1` ASC, CASE WHEN `c3` IS NULL THEN 1 ELSE 0 END, `c3` ASC;

"""


main(sql, "clickhouse", "doris", 'text', '0', False)